<!--[English](README_EN.md)-->

<h1><img src="public/img/favicon.png" alt="logo" width="30" height="30">AiForge - 启智AI开发协作平台</h1>

[![release](https://img.shields.io/badge/release-1.21.11.1-blue)](https://git.openi.org.cn/OpenI/aiforge/releases/latest)
[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg)](https://opensource.org/licenses/MIT)


## AiForge

启智AI开发协作平台是一个在线Web应用，旨在为人工智能算法、模型开发提供在线协同工作环境，它提供了<b>代码托管、数据集管理与共享、免费云端算力资源支持(GPU/NPU)、共享镜像</b>等功能。

[启智AI开发协作平台](https://git.openi.org.cn) 是使用本项目构建的在线服务，您可以直接点击链接访问试用。

本项目是基于[Gitea](https://github.com/go-gitea/gitea)发展而来的，我们对其进行了Fork并基于此扩展了人工智能开发中需要的功能，如数据集管理和模型训练等。对于和代码托管相关的功能，您可以参考[Gitea的文档](https://docs.gitea.io/zh-cn/)。

### 系统总体架构
下图展示了系统总体架构，本项目分为Web前端和服务后端，Web页面面向算法开发者、应用开发者、科研工作者、学生等用户群体，通过统一的Web页面入口，使用系统提供的系统服务。

后端服务涵盖了AI模型开发流水线，包括代码协同开发、数据管理、模型调试、训练、推理和部署等（*目前尚未支持模型部署*）。在不同的开发阶段，我们还将提供丰富的开发工具供用户使用，如数据标注、数据筛选、模型转换、模型压缩、代码检测等。我们也欢迎社区提供更多丰富的工具接入，提高利用平台进行开发的效率。
![系统架构图](assets/架构图.png)
## 在线服务使用
本项目的在线服务平台的详细使用帮助文档，可参阅本项目[百科](https://git.openi.org.cn/OpenI/aiforge/wiki)内容。
- 如何创建账号
- 如何创建组织及管理成员权限
- 如何创建项目仓库
- 如何使用数据集功能
- 如何使用计算资源进行模型调试和训练
- 使用小技巧
- 常见问题(FAQ)
## 安装
您也可以基于本项目代码，在本地环境安装部署服务。
### 数据库准备
[数据库准备说明](https://docs.gitea.io/zh-cn/database-prep/)
### 从源代码安装
- node版本 >= v10.13.0
- golang版本 >= 1.13.3

[从源代码安装说明](https://docs.gitea.io/zh-cn/install-from-source/)

## 授权许可
本项目采用 MIT 开源授权许可证，完整的授权说明已放置在 [LICENSE](https://git.openi.org.cn/OpenI/aiforge/src/branch/develop/LICENSE) 文件中。


## 需要帮助? 
如果您在使用或者开发过程中遇到问题，可以在以下渠道咨询：
 - 点击[这里](https://git.openi.org.cn/OpenI/aiforge/issues)在线提交问题（点击页面右上角绿色按钮**创建任务**）
 - 加入微信群实时交流，获得进一步的支持
   <img src="https://git.openi.org.cn/OpenI/aiforge/wiki/raw/img/wechatgroup.jpg" width=200px />

## 启智社区小白训练营：
- 结合案例给大家详细讲解如何使用社区平台，帮助无技术背景的小白成长为启智社区达人 (https://git.openi.org.cn/zeizei/OpenI_Learning)

## 平台引用
如果本平台对您的科研工作提供了帮助，可在论文致谢中加入：
英文版：```Thanks for the support provided by OpenI Community (https://git.openi.org.cn).```
中文版：```感谢启智社区提供的技术支持(https://git.openi.org.cn)。```

如果您的成果中引用了本平台，也欢迎在下述开源项目中提交您的成果信息：
https://git.openi.org.cn/OpenIOSSG/references
